<?php

namespace App\Dto\Output;

use App\Entity\Partition;
use Symfony\Component\Serializer\Annotation\Groups;

class PartitionOutput extends AbstractOutput
{
    #[Groups(['partition:read'])]
    public ?int $diskNumber = null;

    #[Groups(['partition:read'])]
    public ?string $partitionNumber = null;

    #[Groups(['partition:read'])]
    public ?string $partitionCode = null;

    #[Groups(['partition:read'])]
    public ?int $size = null;

    #[Groups(['partition:read'])]
    public ?string $cacheContent = null;

    #[Groups(['partition:read'])]
    public ?string $filesystem = null;

    #[Groups(['partition:read'])]
    public ?string $osName = null;

    #[Groups(['partition:read'])]
    public ?ClientOutput $client = null;

    #[Groups(['partition:read'])]
    public ?int $memoryUsage = null;

    public function __construct(Partition $partition)
    {
        parent::__construct($partition);

        $this->diskNumber = $partition->getDiskNumber();
        $this->partitionNumber = $partition->getPartitionNumber();
        $this->partitionCode = $partition->getPartitionCode();
        $this->size = $partition->getSize() / 100;
        $this->cacheContent = $partition->getCacheContent();
        $this->filesystem = $partition->getFilesystem();
        $this->osName = $partition->getOsName();
        $this->client = new ClientOutput($partition->getClient());
        $this->memoryUsage = $partition->getMemoryUsage() / 100;
    }

}